commit: d2a9def05500f4e6f403ff56ad9cc54aede11ee7
Author: Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sun Aug 27 17:59:40 2017 +0000
Commit: Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sun Aug 27 18:07:49 2017 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d2a9def0
dev-python/pycparser: Enforce regenerating tables
Remove the pregenerated tables provided in the distfile to force
regenerating them. Generate the tables for every Python implementation
separately to avoid incompatibility/underoptimization problems (tables
built by Python 3.5+ are incompatible with older Python versions that
have 100 group-in-regex limit).
...pycparser-2.18.ebuild => pycparser-2.18-r1.ebuild} | 19 +++++++++++++++++--
1 file changed, 17 insertions(+), 2 deletions(-)
diff --git a/dev-python/pycparser/pycparser-2.18.ebuild
b/dev-python/pycparser/pycparser-2.18-r1.ebuild
similarity index 59%
rename from dev-python/pycparser/pycparser-2.18.ebuild
rename to dev-python/pycparser/pycparser-2.18-r1.ebuild
index 292106b4124..3fb094f6ff3 100644
--- a/dev-python/pycparser/pycparser-2.18.ebuild
+++ b/dev-python/pycparser/pycparser-2.18-r1.ebuild
@@ -21,13 +21,28 @@ DEPEND="${RDEPEND}
dev-python/setuptools[${PYTHON_USEDEP}]
test? ( dev-python/nose[${PYTHON_USEDEP}] )"
+python_prepare_all() {
+ # remove the original files to guarantee their regen
+ rm pycparser/{c_ast,lextab,yacctab}.py || die
+
+ # kill sys.path manipulations to force the tests to use built files
+ sed -i -e '/sys\.path/d' tests/*.py || die
+
+ distutils-r1_python_prepare_all
+}
+
python_compile() {
distutils-r1_python_compile
- pushd "${BUILD_DIR}/lib/pycparser" > /dev/null || die
+
+ # note: tables built by py3.5+ are incompatible with older versions
+ # because of 100 group limit of 're' module -- just generate them
+ # separately optimized for each target instead
+ pushd "${BUILD_DIR}"/lib/pycparser > /dev/null || die
"${PYTHON}" _build_tables.py || die
popd > /dev/null || die
}
python_test() {
- nosetests || die
+ # change workdir to avoid '.' import
+ nosetests -v -w tests || die
}